<?php
namespace Teknisa\SM\Factory;

use Doctrine\ORM\EntityManager;

class SmPerfilDeAcessoDataSoucerFactory
{
    
    protected $connection;
    
    public function __construct(EntityManager $entityManager) {
        
        $this->connection = $entityManager->getConnection();
    }
    
    /**
     * A função "find" Busca os dados para a tela sem ou com filtro
     */
    public function find($filtros) {
        
        $queryDataSource = "SELECT DISTINCT
                                   PERF.NMPERFILACESSO,
                                   PERF.NRPERFILACESSO,
                                   PERF.NRORG
                              FROM PERFILACESSO PERF
                              LEFT JOIN PERFACESSPARC PER
                                ON PER.NRPERFILACESSO = PERF.NRPERFILACESSO
                               AND PER.NRORG = PERF.NRORG
                               LEFT JOIN FCT_PERCDESCPERFIL PERC
                                ON PERC.NRPERFILACESSO = PERF.NRPERFILACESSO
                               AND PERC.NRORG = PERF.NRORG
                               
                            WHERE 1=1 ";
        if (array_key_exists("NRPARCNEGOCIO", $filtros)) {
            $queryDataSource .= "AND PER.NRPARCNEGOCIO IN (".$filtros["NRPARCNEGOCIO"].") ";
        }
        if (array_key_exists("NRPERFILACESSO", $filtros)) {
            $queryDataSource .= "AND PERF.NRPERFILACESSO IN (".$filtros["NRPERFILACESSO"].") ";
        }
            $queryDataSource .= "AND PERC.VRPERCENTUAL IS NOT NULL ";
            $queryDataSource .="ORDER BY PERF.NMPERFILACESSO";
        $std = $this->connection->prepare($queryDataSource);
        $std->execute();
        $returnDataSource = $std->fetchAll();
        return $returnDataSource;
    }
     /**
     * Salva dados na tabela
     */
    public function salvarOperacaoAcresOuDescont(array $params){
        
        $sql= "INSERT INTO FCT_PERCDESCPERFIL (
                    NRSEQDESCPERF,
                    NRPERFILACESSO,
                    VRPERCENTUAL,
                    NRORG,
                    NRORGINCLUSAO,
                    CDOPERINCLUSAO,
                    CDOPERULTATU,
                    NRORGULTATU,
                    DTINCLUSAO,
                    IDATIVO,
                    CDSERVORCA,
                    IDTIPO
                )
                VALUES (
                    :NRSEQDESCPERF,
                    :NRPERFILACESSO,
                    :VRPERCENTUAL,
                    :NRORG,
                    :NRORGINCLUSAO,
                    :CDOPERINCLUSAO,
                    :CDOPERULTATU,
                    :NRORGULTATU,
                    SYSDATE,
                    :IDATIVO,
                    :CDSERVORCA,
                    :IDTIPO
                )";
        
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        
    }
}
?>